Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts2.views.xslt
Class AdapterFactory

    java.lang.Object
      org.apache.struts2.views.xslt.AdapterFactory

    public class AdapterFactory

extends Object

AdapterFactory produces Node adapters for Java object types. Adapter classes are generally instantiated dynamically via a no-args constructor and populated with their context information via the AdapterNode interface. This factory supports proxying of generic DOM Node trees, allowing arbitrary Node types to be mixed together. You may simply return a Document or Node type as an object property and it will appear as a sub-tree in the XML as you'd expect. See #proxyNode(). Customization of the result XML can be accomplished by providing alternate adapters for Java types. Adapters are associated with Java types through the registerAdapterType() method. For example, since there is no default Date adapter, Date objects will be rendered with the generic Bean introspecting adapter, producing output like:

            19
            1
            0
            7
            8
            4
            1127106424531
            300
            105

By extending the StringAdapter and overriding its normal behavior we can create a custom Date formatter:

          public static class CustomDateAdapter extends StringAdapter {
            protected String getStringValue() {
                Date date = (Date)getPropertyValue();
                return DateFormat.getTimeInstance( DateFormat.FULL ).format( date );
            }
        }

Producing output like:

         12:02:54 AM CDT

The StringAdapter (which is normally invoked only to adapt String values) is a useful base for these kinds of customizations and can produce structured XML output as well as plain text by setting its parseStringAsXML() property to true. See provided examples.

Field Summary
`private Map<Class,Class>` | `adapterTypes`

Constructor Summary
`AdapterFactory()`

Method Summary
`Document` | `adaptDocument(String propertyName, Object propertyValue)` Create a top level Document adapter for the specified Java object.
`Node` | `adaptNode(AdapterNode parent, String propertyName, Object value)` Create an Node adapter for a child element.
`Node` | `adaptNullValue(BeanAdapter parent, String propertyName)` Create an appropriate adapter for a null value.
`private Node` | `constructAdapterInstance(Class adapterClass, AdapterNode parent, String propertyName, Object propertyValue)` Create an instance of an adapter dynamically and set its context via the AdapterNode interface.
`Class` | `getAdapterForValue(Object value)`
`NamedNodeMap` | `proxyNamedNodeMap(AdapterNode parent, NamedNodeMap nnm)`
`Node` | `proxyNode(AdapterNode parent, Node node)` Construct a proxy adapter for a value that is an existing DOM Node.
`void` | `registerAdapterType(Class type, Class adapterType)` Register an adapter type for a Java class type.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### adapterTypes

    private Map<Class,Class> adapterTypes

Constructor Detail

### AdapterFactory

    public AdapterFactory()

Method Detail

### registerAdapterType

    public void registerAdapterType(Class type,
                                    Class adapterType)

  Register an adapter type for a Java class type.

  Parameters:
    `type` - the Java class type which is to be handled by the adapter.
    `adapterType` - The adapter class, which implements AdapterNode.

### adaptDocument

    public Document adaptDocument(String propertyName,
                                  Object propertyValue)
                           throws IllegalAccessException,
                                  InstantiationException

  Create a top level Document adapter for the specified Java object. The document will have a root element with the specified property name and contain the specified Java object content.

  Parameters:
    `propertyName` - The name of the root document element
  Returns:
  Throws:
    `IllegalAccessException`
    `InstantiationException`

### adaptNode

    public Node adaptNode(AdapterNode parent,
                          String propertyName,
                          Object value)

  Create an Node adapter for a child element. Note that the parent of the created node must be an AdapterNode, however the child node itself may be any type of Node.

  See Also:
    `adaptDocument( String, Object )`

### proxyNode

    public Node proxyNode(AdapterNode parent,
                          Node node)

  Construct a proxy adapter for a value that is an existing DOM Node. This allows arbitrary DOM Node trees to be mixed in with our results. The proxied nodes are read-only and currently support only limited types of Nodes including Element, Text, and Attributes. (Other Node types may be ignored by the proxy and not appear in the result tree).

  // TODO: NameSpaces are not yet supported.

  This method is primarily for use by the adapter node classes.

### proxyNamedNodeMap

    public NamedNodeMap proxyNamedNodeMap(AdapterNode parent,
                                          NamedNodeMap nnm)

### constructAdapterInstance

    private Node constructAdapterInstance(Class adapterClass,
                                          AdapterNode parent,
                                          String propertyName,
                                          Object propertyValue)

  Create an instance of an adapter dynamically and set its context via the AdapterNode interface.

### adaptNullValue

    public Node adaptNullValue(BeanAdapter parent,
                               String propertyName)

  Create an appropriate adapter for a null value.

  Parameters:
    `parent` -
    `propertyName` -

### getAdapterForValue

    public Class getAdapterForValue(Object value)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Apache Software Foundation. All Rights Reserved.